#include "system.h"
#include "interrupt.h"
#include "video.h"

struct_pyos_InterruptItem class_pyos_Interrupt::m_Idt[ 256 ] ; // ж
struct_pyos_Idtr class_pyos_Interrupt::m_Idtr ; // ж

/* ʼжϿ 8259A */
void class_pyos_Interrupt::Init8259A()
{
  // жϼĴ
  //  ICW1 : ʹ ICW4
  class_pyos_System::ToPort( 0x20 , 0x11 ) ;
  class_pyos_System::ToPort( 0xa0 , 0x11 ) ;

  //  ICW2жʼŴ 0x20 ʼһƬ 0x28ʼڶƬ
  class_pyos_System::ToPort( 0x21 , 0x20 ) ; 
  class_pyos_System::ToPort( 0xa1 , 0x28 ) ;

  //  ICW3
  class_pyos_System::ToPort( 0x21 , 0x4 ) ;
  class_pyos_System::ToPort( 0xa1 , 0x2 ) ;

  //  ICW4
  class_pyos_System::ToPort( 0x21 , 0x1 ) ;
  class_pyos_System::ToPort( 0xa1 , 0x1 ) ;

  // жλ OCW1 ж 
  class_pyos_System::ToPort( 0x21 , 0xff ) ;
  class_pyos_System::ToPort( 0xa1 , 0xff ) ;
}
/* ʼж */
void class_pyos_Interrupt::InitInterruptTable()
{
  /* жָһжϣҪʱд */ 
  struct_pyos_InterruptItem tmp ;
  tmp.Offset_0_15 = ( unsigned int )pyos_asm_interrupt_handle_for_default ;
  tmp.Offset_16_31 = ( unsigned int )pyos_asm_interrupt_handle_for_default >> 16 ;
  tmp.SegSelector = 0x8 ; // 
  tmp.UnUsed = 0 ;
  tmp.P = 1 ;
  tmp.DPL = 0 ;
  tmp.Saved_1_1_0 = 6 ;
  tmp.Saved_0 = 0 ;
  tmp.D = 1 ;

  for( int i = 0 ; i < 256 ; ++i ){
    m_Idt[ i ] = tmp ;
  }

  m_Idtr.IdtAddr = m_Idt ;
  m_Idtr.IdtLengthLimit = 256 * 8 -1 ; //  256ÿռ8ֽ

  // Ƕ࣬ ldt
  __asm__( "lidt %0" : "=m"( m_Idtr ) ) ; //GDT
}
/* ʼжϷ */
void class_pyos_Interrupt::Init()
{
  /* ʼжϿɱ̿ؼ 8259A */
  Init8259A() ;
  /* ʼж */
  InitInterruptTable() ;
  /* ɼж */
  class_pyos_System::ToPort( 0x21 , 0xfd ) ;
  /* ָж */
  __asm__( "sti" ) ;
}
/* Ĭжϴ */
extern "C" void pyos_interrupt_handle_for_default()
{
  /* ж */
  /*  0x60 ˿ڣüɨ */
  char ch = class_pyos_System::FromPort( 0x60 ) ;
  /* ʾɨ */
  class_pyos_Video::PrintMessage( ch ) ;
}
