#include "system.h"
#include "video.h"
#include "interrupt.h"

struct_pyos_Gdtr class_pyos_System::m_gdtr ;
struct_pyos_Gdt class_pyos_System::m_gdt ;
/* ϵͳʼ */
void class_pyos_System::Init()  
{
  /* ʼGdt */
  InitGdt() ; 
  /* ʼμĴ */
  InitSegRegister() ; 
  /* ʼж */
  class_pyos_Interrupt::Init() ;
}
/* ʼμĴ */
void class_pyos_System::InitSegRegister()
{
  __asm__( "mov $0x10 , %ax" ) ; //ʹõgdtеĵ3 gdtSystemDate
  __asm__( "mov %ax , %ds" ) ;
  __asm__( "mov %ax , %ss" ) ;
  __asm__( "mov %ax , %es" ) ;
  __asm__( "mov %ax , %fs" ) ;
  __asm__( "mov %ax , %gs" ) ;
  __asm__( "mov $0x9ffff , %esp" ) ; //öջ0xA0000ʼʾڴ
}
/* ˿ */
unsigned char class_pyos_System::FromPort( unsigned short port )
{
  /* 
     % ʾǼĴ
     =a(result) ʾ result = eax
	   d(port) ʾ edx = port 
  */
  unsigned char result ;
  __asm__( "in %%dx , %%al" : "=a"( result ) : "d"( port ) ) ;
  return result ;
}
/* д˿ */
void class_pyos_System::ToPort( unsigned short port , unsigned char data )
{
  __asm__( "out %%al , %%dx" : : "a"( data ) , "d"( port ) ) ;
}
/* ʼGDT */
void class_pyos_System::InitGdt()
{
  m_gdtr.GdtLengthLimit = sizeof( m_gdt ) - 1 ;
  m_gdtr.GdtAddr = &m_gdt ;

  m_gdt.gdtSystemCode.DorB = 1 ;
  m_gdt.gdtSystemCode.DPL = 0 ;
  m_gdt.gdtSystemCode.G = 1 ;
  m_gdt.gdtSystemCode.P = 1 ;
  m_gdt.gdtSystemCode.S = 1 ;
  m_gdt.gdtSystemCode.Saved = 0 ;
  m_gdt.gdtSystemCode.SegBaseAddr_0_15 = 0 ;
  m_gdt.gdtSystemCode.SegBaseAddr_16_23 = 0 ;
  m_gdt.gdtSystemCode.SegBaseAddr_24_31 = 0 ;
  m_gdt.gdtSystemCode.SegLengthLimit_0_15 = 0xffff ;
  m_gdt.gdtSystemCode.SegLengthLimit_16_19 = 0xff ;
  m_gdt.gdtSystemCode.Type = 0xa ;
  
  m_gdt.gdtSystemDate = m_gdt.gdtSystemCode ;
  m_gdt.gdtSystemDate.Type = 0x2 ;

  m_gdt.gdtUserCode = m_gdt.gdtSystemCode ;
  m_gdt.gdtUserCode.DPL = 3 ;

  m_gdt.gdtUserDate = m_gdt.gdtUserCode ;
  m_gdt.gdtUserDate.Type = 0x2 ;

  // Ƕgdt
  __asm__( "lgdt %0" : "=m"( m_gdtr ) ) ; //GDT
}

